"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.valit = void 0;
const symbols_1 = require("./symbols");
const utils_1 = require("./utils");
function valit(name, fn, handleOptions, defaultOptions) {
    return (...args) => {
        const getFnWithValitWithOptions = (options) => (value, path, parent) => {
            const data = fn(...args)(value, path, options, parent);
            if (!data.valid)
                return data;
            if (handleOptions === undefined)
                return data;
            (0, utils_1.assert)(value);
            const optionsWithDefault = Object.assign(Object.assign({}, defaultOptions), options);
            const keysWithError = Object.keys(optionsWithDefault).filter(k => handleOptions[k] !== undefined && !handleOptions[k](value, optionsWithDefault[k], options));
            if (keysWithError.length === 0)
                return data;
            return {
                valid: false,
                data: undefined,
                errors: keysWithError.map(k => ({
                    message: k in options ? `vality.${name}.options.${k}` : `vality.${name}.base`,
                    options,
                    path,
                    value,
                })),
            };
        };
        return Object.assign((options) => {
            return {
                [symbols_1._validate]: (val, path, parent) => {
                    if (typeof options === "function")
                        options = options(parent);
                    return getFnWithValitWithOptions(options)(val, path);
                },
                [symbols_1._type]: undefined,
            };
        }, {
            [symbols_1._validate]: getFnWithValitWithOptions({}),
            [symbols_1._type]: undefined,
        });
    };
}
exports.valit = valit;
